
; CC5X Version 3.4E, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  29. Sep 2014  21:46  *************

	processor  16F628
	radix  DEC

	__config 0x3F18

TMR0        EQU   0x01
PCL         EQU   0x02
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
INTEDG      EQU   6
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
INTF        EQU   1
T0IF        EQU   2
INTE        EQU   4
GIE         EQU   7
OPTION_REG  EQU   0x81
T2CON       EQU   0x12
CCPR1L      EQU   0x15
CCP1CON     EQU   0x17
CMCON       EQU   0x1F
PR2         EQU   0x92
EEDATA      EQU   0x9A
EEADR       EQU   0x9B
EECON2      EQU   0x9D
EEIF        EQU   7
RD          EQU   0
WR          EQU   1
WREN        EQU   2
dim_grade   EQU   0x26
dim_1       EQU   0x27
dim_2       EQU   0x28
duty        EQU   0x29
ircode      EQU   0x2A
save_counter EQU   0x2C
irled       EQU   0x2E
old_dim_grade EQU   0x2F
tmr0cpy     EQU   0x30
irledn      EQU   0
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
adr         EQU   0x22
data        EQU   0x23
prev_gie    EQU   0
adr_2       EQU   0x23
t           EQU   0x24
t_2         EQU   0x24
i           EQU   0x25
ton         EQU   0x22
toff        EQU   0x23
h           EQU   0x22
tmp         EQU   0x21
ci          EQU   0x23

	GOTO main

  ; FILE d:\projekte\picsel\dimmer\dimmer.c
			;/* DIMMER VERSION 1.1                             */
			;/*                                                */
			;/*                __    _                         */                     
			;/*     __________/ /_  (_)________   ___  __  __  */ 
			;/*    / ___/ ___/ __ \/ / ___/ __ \ / _ \/ / / /  */
			;/*   (__  ) /__/ / / / / /  / /_/ //  __/ /_/ /   */
			;/*  /____/\___/_/ /_/_/_/  / .___(_)___/\__,_/    */
			;/*                        /_/                     */
			;/*                                                */
			;/* (c) C.Schirp  released for non-commercial use  */
			;/* IR-routines copyright by Jos van Eijndhoven    */
			;/*                                                */
			;/* V1.0  Erstausgabe                              */
			;/* V1.1  EVG-Lichtstromkorrektur                  */
			;/*                                                */
			;
			;
			;#include <d:\projekte\picsel\cc5\16F628.h>
			;#include <d:\projekte\picsel\cc5\int16CXX.h>
			;
			;#pragma config = 0x3F18
			;// Standard ohne ext reset 0x3F18
			;// Standard mit ext Reset  0x3F38 
			;
			;#define HARD_PWM
			;
			;/* Defines */
			;
			;#define INPUT 1
			;#define OUTPUT 0
			;
			;#define MIN_DIM 1	/* minimaler Dimgrad */
			;#define MAX_DIM 10	/* maximaler Dimgrad */
			;
			;#define SAVETIME	625	/* nach SAVETIME mal 8ms wird der dimwert ins eeprom geschrieben */
			;
			;unsigned char dim_grade;	 //debounced and inverted dimming grade 10...100:
			;unsigned char dim_1;
			;unsigned char dim_2;
			;//const unsigned char dtable[11] = {0, 26, 34, 43, 56, 72, 92,119,154,198,255}; // tabelle aus microcontroller.net/LED-Fading
			;const unsigned char dtable[11] = {0, 64, 73, 82, 95,108,125,146,174,210,255}; // korrektur LED-Fading und Quicktronic-Lichtstrom-Graph
			;unsigned char duty;
			;
			;uns16  ircode;
			;uns16  save_counter;
			;unsigned char irled; // 1 if light is on
			;unsigned char old_dim_grade;
			;
			;
			;unsigned char tmr0cpy;
			;
			;
			;
			;//bit Monitor; // Shadow fuer PB6
			;
			;bit irledn     @ PORTB.0;
			;
			;/*------------------------------------------------------------------*/
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*------------------------------------------------------------------*/
			;
			;
			;#pragma origin 4
	ORG 0x0004
			;interrupt int_server( void)
			;{
int_server
			;    int_save_registers    // W, STATUS (and PCLATH)
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;
			;    if ( INTF)
	BTFSS 0x0B,INTF
	GOTO  m003
			;    {
			;        /* RB0/INT interrupt */
			;        irled.0 = !irledn;
	BSF   irled,0
	BTFSC 0x06,irledn
	BCF   irled,0
			;        INTF = 0;
	BCF   0x0B,INTF
			;        if (irled)     // request interrupt on next edge (up or down)
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m001
			;           INTEDG = 1; // if 1, then interrupt on rising edge
	BSF   0x03,RP0
	BSF   0x81,INTEDG
			;        else
	GOTO  m002
			;           INTEDG = 0; // is part of OPTION_REG, is 1 on reset
m001	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x81,INTEDG
			;
			;        /* finish and restart TMR0 */
			;        tmr0cpy = TMR0;
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	MOVWF tmr0cpy
			;        TMR0 = 0;
	CLRF  TMR0
			;        T0IF = 1; // end polling wait-loop, similar to TRM0 wraparound
	BSF   0x0B,T0IF
			;    }
			;
			;   /*
			;     NOTE: GIE is AUTOMATICALLY cleared on interrupt entry and set
			;           to 1 on exit (by RETFIE). Setting GIE to 1 inside the
			;           interrupt service routine will cause nested interrupts
			;           if an interrupt is pending. Too deep nesting may crash
			;           the program !
			;   */
			;
			;    int_restore_registers // W, STATUS (and PCLATH)
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;
			;void init ()
			;{
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ci
	MOVLW 11
	SUBWF ci,W
	BTFSS 0x03,Carry
	GOTO  m004
	RETLW 0
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PCLATH
	MOVF  ci,W
	ADDWF PCL,1
	RETLW 0
	RETLW 64
	RETLW 73
	RETLW 82
	RETLW 95
	RETLW 108
	RETLW 125
	RETLW 146
	RETLW 174
	RETLW 210
	RETLW 255
init
			;	
			;	
			;	/* PORT A Config */
			;	CMCON = 0x07;		// kein Komparator
	MOVLW 7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF CMCON
			;
			;	TRISB = 0b0000.0001; 	// Alles Ausgnge - nur RB0/Int Eingang
	MOVLW 1
	BSF   0x03,RP0
	MOVWF TRISB
			;	TRISA = 0b0000.0000;	// alles Output
	CLRF  TRISA
			;	
			;	PORTB = 0b0000.0000;	// HINT: erst Direction, dann Wert!
	BCF   0x03,RP0
	CLRF  PORTB
			;	PORTA = 0x00;	
	CLRF  PORTA
			;
			;
			;	/*sonstiges*/
			;	OPTION_REG = 0x84;/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW 132
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	
			;#ifdef HARD_PWM
			;	/* Timer 1 und Timer 2 fr PWM konfigurieren */
			;	PR2 = 0xFF;		// Periode: 255 Takte
	MOVLW 255
	MOVWF PR2
			;	CCPR1L = 0;		// Duty = 0
	BCF   0x03,RP0
	CLRF  CCPR1L
			;	T2CON = 0x05;		// Timer 2 = 0n, Prescaler = 4   (-> 4MHz/4/1024/4 => ca. 244Hz PWM-Grundfrequenz)	
	MOVLW 5
	MOVWF T2CON
			;	CCP1CON=12;		// Timer1 im PWM-mode  (8-Bit PWM, LSBs des Duty Cycle nicht benutzt)
	MOVLW 12
	MOVWF CCP1CON
			;#endif
			;
			;
			;
			;	/* Variablen initialisieren */
			;	dim_grade = MIN_DIM;	// 10% minimum
	MOVLW 1
	MOVWF dim_grade
			;	save_counter = 0; 	// nix schreiben
	CLRF  save_counter
	CLRF  save_counter+1
			;	
			;	irled = 	0;
	CLRF  irled
			;
			;
			;	INTCON = 0; 			// reset and disable all interrupts by default
	CLRF  INTCON
			;	INTE = 	1;
	BSF   0x0B,INTE
			;	GIE = 	 1;				// Enable Interrupts
	BSF   0x0B,GIE
			;	
			;
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*    EEEE  EEEE  PPPP   RRRR    OOO   M     M                      */
			;/*    E     E     P   P  R   R  O   O  MM   MM                      */
			;/*    EEE   EEE   PPPP   RRRR   O   O  M M M M                      */
			;/*    E     E     P      R R    O   O  M  M  M                      */
			;/*    EEEE  EEEE  P      R  R    OOO   M     M                      */
			;/*------------------------------------------------------------------*/
			;
			;
			;
			;void write_eeprom( unsigned char adr, unsigned char data)
			;{
write_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF data
			;	bit prev_gie = GIE;
	BCF   0x24,prev_gie
	BTFSC 0x0B,GIE
	BSF   0x24,prev_gie
			;	GIE = 0; 		// disable interrupts
	BCF   0x0B,GIE
			;	EEIF = 0; 		// clear eprom interrupt flag
	BCF   0x0C,EEIF
			;
			;	while (WR)
m005	BSF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x9C,WR
	GOTO  m006
			;		; 			// wait if previous write is still busy
	GOTO  m005
			;
			;	EEADR = adr; 	// valid range is from 00h to 7Fh (128 bytes)
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  adr,W
	BSF   0x03,RP0
	MOVWF EEADR
			;	EEADR &= 0x7f; 	// prevent bugs to overwrite program memory
	BCF   EEADR,7
			;	EEDATA = data;
	BCF   0x03,RP0
	MOVF  data,W
	BSF   0x03,RP0
	MOVWF EEDATA
			;	WREN = 1;
	BSF   0x9C,WREN
			;	EECON2 = 0x55;
	MOVLW 85
	MOVWF EECON2
			;	EECON2 = 0xAA;
	MOVLW 170
	MOVWF EECON2
			;	WR = 1; 		// start the actual write
	BSF   0x9C,WR
			;
			;	WREN = 0; 		// protect against unintended writes
	BCF   0x9C,WREN
			;	GIE = prev_gie; // restore interrupts
	BCF   0x03,RP0
	BTFSS 0x24,prev_gie
	BCF   0x0B,GIE
	BTFSC 0x24,prev_gie
	BSF   0x0B,GIE
			;}
	RETURN
			;
			;unsigned char read_eeprom( unsigned char adr)
			;{
read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr_2
			;	EEADR = adr; 	// valid range is from 00h to 7Fh (128 bytes)
	MOVF  adr_2,W
	BSF   0x03,RP0
	MOVWF EEADR
			;	EEADR &= 0x7f; 	// prevent bugs to exceed program memory
	BCF   EEADR,7
			;	RD = 1;
	BSF   0x9C,RD
			;	return EEDATA;
	MOVF  EEDATA,W
	RETURN
			;}
			;
			;/*------------------------------------------------------------------*/
			;/*    K  K  EEEE  Y   Y   SSS                                       */
			;/*    K K   E      Y Y   S                                          */
			;/*    KK    EE      Y     SSS                                       */
			;/*    K K   E       Y        S                                      */
			;/*    K  K  EEEE    Y     SSS                                       */
			;/*------------------------------------------------------------------*/
			;
			;
			;void restore_state(void)
			;{
restore_state
			;	unsigned char tester;
			;
			;	dim_grade = read_eeprom(0);
	MOVLW 0
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF dim_grade
			;	dim_1 = read_eeprom(1);
	MOVLW 1
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF dim_1
			;	dim_2 = read_eeprom(2);
	MOVLW 2
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF dim_2
			;
			;	// 2 aus 3
			;	if (dim_grade==dim_1)
	MOVF  dim_grade,W
	XORWF dim_1,W
	BTFSS 0x03,Zero_
	GOTO  m007
			;	{
			;	}
			;	else if (dim_grade==dim_2)
	GOTO  m009
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  dim_grade,W
	XORWF dim_2,W
	BTFSS 0x03,Zero_
	GOTO  m008
			;	{
			;	}
			;	else if (dim_1 == dim_2)
	GOTO  m009
m008	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  dim_1,W
	XORWF dim_2,W
	BTFSS 0x03,Zero_
	GOTO  m009
			;	{
			;		dim_grade = dim_1;
	MOVF  dim_1,W
	MOVWF dim_grade
			;	}
			;
			;	// Gueltigkeit pruefen
			;	if (dim_grade < MIN_DIM)
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  dim_grade,1
	BTFSS 0x03,Zero_
	GOTO  m010
			;	{
			;		dim_grade = MIN_DIM;
	MOVLW 1
	MOVWF dim_grade
			;	}
			;	else if (dim_grade > MAX_DIM)
	GOTO  m011
m010	MOVLW 11
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF dim_grade,W
	BTFSS 0x03,Carry
	GOTO  m011
			;	{
			;		dim_grade = MAX_DIM;
	MOVLW 10
	MOVWF dim_grade
			;	}
			;	
			;	old_dim_grade = dim_grade;	// alten dimgrad setzen, damit er nicht ins EEPROM geschrieben wird
m011	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  dim_grade,W
	MOVWF old_dim_grade
			;	
			;	duty = dtable[dim_grade];
	MOVF  dim_grade,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF duty
			;			
			;	CCPR1L = duty;
	MOVF  duty,W
	MOVWF CCPR1L
			;
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*    RRR    CCC    55555                                           */
			;/*    R  R  C   C   5                                               */
			;/*    RRR   C       5555                                            */
			;/*    R R   C   C       5                                           */
			;/*    R  R   CCC    5555                                            */
			;/*------------------------------------------------------------------*/
			;
			;// 4MHz crystal, 1MHz cycle time, TMR0 prescale=32: timer units of 32 usec.
			;// TRM0 expires at 8 msec.
			;
			;extern uns8 tmr0wait( void)
			;{
tmr0wait
			;	tmr0cpy = 0xff; // potential longest waiting time, reduced by irled
	MOVLW 255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tmr0cpy
			;	while (!T0IF) // wait for TMR0 wrap-around or IRled
m012	BTFSC 0x0B,T0IF
	GOTO  m013
			;		;
	GOTO  m012
			;
			;	T0IF = 0;
m013	BCF   0x0B,T0IF
			;	return tmr0cpy;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmr0cpy,W
	RETURN
			;}
			;
			;void ir_bogus( void)
			;{
ir_bogus
			;	// just eat irled input, as long as we have fast pulses
			;	uns8 t;
			;
			;	t = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  t
			;	while (t < 200)
m014	MOVLW 200
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF t,W
	BTFSC 0x03,Carry
	GOTO  m015
			;	   t = tmr0wait();
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t
	GOTO  m014
			;
			;	ircode = 0xffffL; // bogus code;
m015	MOVLW 255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ircode
	MOVLW 255
	MOVWF ircode+1
			;}
	RETURN
			;
			;void ir_philips_rc5(void) // now assuming no 'extended' RC5, so S2==1
			;{
ir_philips_rc5
			;	// 1 is sequence dark,light:  2x 900us == 2x28
			;	// 0 is sequence light,dark:  2x 900us == 2x28
			;	// frame is: one,one,toggle,11xdata
			;	unsigned char t;
			;	unsigned char i;
			;
			;	t = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  t_2
			;	i = 0;
	CLRF  i
			;	ircode = 0L;
	CLRF  ircode
	CLRF  ircode+1
			;	// starting now in the 2nd (light) half S2
			;	while (t < 80)
m016	MOVLW 80
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m019
			;	{
			;	   // last half of current bit still to be measured, its timer is running
			;	   ircode <<=1; // insert current value
	BCF   0x03,Carry
	RLF   ircode,1
	RLF   ircode+1,1
			;	   if (irled) // irled input is active low
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m017
			;		   ircode.0 = 1;
	BSF   ircode,0
			;	   i++;
m017	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,1
			;
			;	   t = tmr0wait();
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t_2
			;
			;	   if (t < 38) // new codebit is same as current, edge at bit boundary
	MOVLW 38
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m018
			;	   {
			;	   	  t=tmr0wait(); // skip first half of new bit
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t_2
			;	   }
			;	}
m018	GOTO  m016
			;
			;	ircode.high8 &= 0x07; // clear start bits S2 and T
m019	MOVLW 7
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode+1,1
			;
			;	if (i < 13)
	MOVLW 13
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m020
			;	{
			;		ircode = 0xffffL; // bogus
	MOVLW 255
	MOVWF ircode
	MOVLW 255
	MOVWF ircode+1
			;	}
			;}
m020	RETURN
			;
			;
			;void get_ir( void)
			;{
get_ir
			;	unsigned char ton;
			;	unsigned char toff;
			;
			;    ton = tmr0wait(); // measure first light
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ton
			;	toff = tmr0wait(); // following first dark
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF toff
			;
			;    if (ton  > 20 && ton  < 36 &&  // nominal 900/32 = 28
	MOVLW 21
	SUBWF ton,W
	BTFSS 0x03,Carry
	GOTO  m021
	MOVLW 36
	SUBWF ton,W
	BTFSC 0x03,Carry
	GOTO  m021
			;        toff > 20 && toff < 36)  // nominal 900/32 = 28
	MOVLW 21
	SUBWF toff,W
	BTFSS 0x03,Carry
	GOTO  m021
	MOVLW 36
	SUBWF toff,W
	BTFSC 0x03,Carry
	GOTO  m021
			;    {
			;		ir_philips_rc5();
	CALL  ir_philips_rc5
			;	}
			;	else
	GOTO  m022
			;	{
			;		ir_bogus();
m021	GOTO  ir_bogus
			;	}
			;}
m022	RETURN
			;
			;void do_remote(void)
			;{
do_remote
			;	unsigned char h;
			;
			;
			;
			;	// systemadresse testen
			;	h = ircode.high8 & 0b.0000.0111;
	MOVLW 7
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode+1,W
	MOVWF h
			;	if (h != 4)
	MOVF  h,W
	XORLW 4
	BTFSC 0x03,Zero_
	GOTO  m023
			;	{
			;		return;
	RETURN
			;	}
			;
			;	h = ircode.low8 & 0b.1100.0000;
m023	MOVLW 192
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode,W
	MOVWF h
			;	if (h != 0)
	MOVF  h,1
	BTFSC 0x03,Zero_
	GOTO  m024
			;	{
			;		return;
	RETURN
			;	}
			;
			;	// okay, Kommando gilt uns: Kommando extrahieren
			;	h= ircode.low8 & 0b.0011.1111;
m024	MOVLW 63
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode,W
	MOVWF h
			;
			;	// Quellenwahltasten = 1..8
			;	if (h<=9)
	MOVLW 10
	SUBWF h,W
	BTFSC 0x03,Carry
	GOTO  m025
			;	{
			;	
			;		dim_grade = h;
	MOVF  h,W
	MOVWF dim_grade
			;
			;	}
			;	
			;	// Sonderfall 0/10
			;	if (h == 0)
m025	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,1
	BTFSS 0x03,Zero_
	GOTO  m026
			;	{
			;		dim_grade = 10;
	MOVLW 10
	MOVWF dim_grade
			;	}
			;
			;	if (h == 16) // Volume +
m026	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW 16
	BTFSS 0x03,Zero_
	GOTO  m028
			;	{
			;		if (dim_grade <= 9)
	MOVLW 10
	SUBWF dim_grade,W
	BTFSC 0x03,Carry
	GOTO  m027
			;		{
			;			dim_grade++;
	INCF  dim_grade,1
			;		}
			;	}
			;	else if (h == 17) // Volume -
m027	GOTO  m029
m028	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW 17
	BTFSS 0x03,Zero_
	GOTO  m029
			;	{
			;		if (dim_grade > 1)
	MOVLW 2
	SUBWF dim_grade,W
	BTFSS 0x03,Carry
	GOTO  m029
			;		{
			;			dim_grade--;
	DECF  dim_grade,1
			;		}
			;		
			;	}
			;
			;
			;}
m029	RETURN
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;	unsigned char tmp;
			;
			;	init();
	CALL  init
			;
			;	restore_state();
	CALL  restore_state
			;
			;	
			;	//CLRWDT;
			;	//clrwdt();
			;
			;	while (1)
			;	{
			;
			;
			;		tmp = tmr0wait(); // wrap-around or interrupt, wrap-around takes 8ms
m030	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tmp
			;	
			;		//pause(10);
			;
			;	    	if (irled) //came out of wait by interrupt: light on, start of new code
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m031
			;		{
			;			get_ir();
	CALL  get_ir
			;			do_remote();
	CALL  do_remote
			;		}
			;		
			;		// wenn sich der dimmgrad gendert hat, schreiben
			;		if (old_dim_grade != dim_grade)
m031	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  old_dim_grade,W
	XORWF dim_grade,W
	BTFSC 0x03,Zero_
	GOTO  m032
			;		{
			;			save_counter = SAVETIME;
	MOVLW 113
	MOVWF save_counter
	MOVLW 2
	MOVWF save_counter+1
			;			
			;			old_dim_grade = dim_grade;
	MOVF  dim_grade,W
	MOVWF old_dim_grade
			;			
			;			duty = dtable[dim_grade];
	MOVF  dim_grade,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF duty
			;			
			;			CCPR1L = duty;
	MOVF  duty,W
	MOVWF CCPR1L
			;			
			;		}
			;		
			;		// wartezeit vor dem speichern abgelaufen?
			;		if (save_counter == 1)
m032	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  save_counter,W
	IORWF save_counter+1,W
	BTFSS 0x03,Zero_
	GOTO  m033
			;		{
			;		
			;			write_eeprom(0,dim_grade);
	CLRF  adr
	MOVF  dim_grade,W
	CALL  write_eeprom
			;			write_eeprom(1,dim_grade);
	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr
	MOVF  dim_grade,W
	CALL  write_eeprom
			;			write_eeprom(2,dim_grade);
	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr
	MOVF  dim_grade,W
	CALL  write_eeprom
			;			
			;			save_counter = 0; // speichern erledigt
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  save_counter
	CLRF  save_counter+1
			;		}
			;		else if (save_counter > 1)
	GOTO  m035
m033	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  save_counter+1,W
	BTFSS 0x03,Zero_
	GOTO  m034
	MOVLW 2
	SUBWF save_counter,W
	BTFSS 0x03,Carry
	GOTO  m035
			;		{
			;			save_counter--;
m034	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  save_counter,1
	INCF  save_counter,W
	BTFSC 0x03,Zero_
	DECF  save_counter+1,1
			;		}
			;		
			;		//clrwdt();
			;
			;	} /* while (1) */
m035	GOTO  m030

	END


; *** KEY INFO ***

; 0x0004   33 word(s)  1 % : int_server
; 0x003D   31 word(s)  1 % : init
; 0x005C   36 word(s)  1 % : write_eeprom
; 0x0080   10 word(s)  0 % : read_eeprom
; 0x008A   63 word(s)  3 % : restore_state
; 0x0025   24 word(s)  1 % : _const1
; 0x00C9   12 word(s)  0 % : tmr0wait
; 0x00D5   21 word(s)  1 % : ir_bogus
; 0x00EA   48 word(s)  2 % : ir_philips_rc5
; 0x011A   28 word(s)  1 % : get_ir
; 0x0136   61 word(s)  2 % : do_remote
; 0x0173   72 word(s)  3 % : main

; RAM usage: 18 bytes (7 local), 206 bytes free
; Maximum call level: 3 (+1 for interrupt)
; Total of 440 code words (21 %)
